#include <stdafx.h>
#include <stdio.h>
#include <string.h>
#include <windows.h>
#include <stdlib.h>


#include "myString.h"
#include "myException.h"

// *********************************************************************************

CMyString::CMyString()
{
	isOwnerBuffer = FALSE;
	size = 0;
	allocSize = 0;
	value = NULL;
}

CMyString::CMyString(char letter)
{
	isOwnerBuffer = FALSE;
	value = NULL;
	*this=letter;
}

CMyString::CMyString(int integer)
{
	isOwnerBuffer = FALSE;
	value = NULL;
	*this=integer;
}

CMyString::CMyString(long linteger)
{
	isOwnerBuffer = FALSE;
	value = NULL;
	*this=linteger;
}

CMyString::CMyString(float floating)
{
	isOwnerBuffer = FALSE;
	value = NULL;
	*this=floating;
}

CMyString::CMyString(double lfloating)
{
	isOwnerBuffer = FALSE;
	value = NULL;
	*this=lfloating;
}

CMyString::CMyString(char *string,BOOL _isOwnerBuffer)
{
	isOwnerBuffer = _isOwnerBuffer;
	value = NULL;
	if (!string) throw CMyException("CMyString","constructor","parameter string is null");
	if (isOwnerBuffer)
	{
		Delete();
		value = string;
		size = strlen(string);
		allocSize = INFINITE;
	}
	else *this=string;
}

CMyString::CMyString(CMyString &string)
{
	isOwnerBuffer = FALSE;
	value = NULL;
	*this=string;
}

// *********************************************************************************

CMyString::~CMyString()
{
	Delete();
}

// *********************************************************************************

void CMyString::Delete()
{
	if (value!=NULL && !isOwnerBuffer) delete []value;
	size = 0;
	allocSize = 0;
	value = NULL;
}

// *********************************************************************************

BOOL CMyString::IsEmpty()
{
	return size == 0;
}

// *********************************************************************************

CMyString & CMyString::operator=(char letter) // string.operator=(char letter);
{
	Delete();
	size = 1;
	allocSize = 2;
	value = new char[allocSize];
	if (!value) throw CMyExceptionMemory("CMyString","operator=",allocSize);
	value[0]= letter;
	value[1]= '\0';
	return *this; // pour: s=t=u="coucou";
}

CMyString & CMyString::operator=(int integer)
{
	char temp[40];
	sprintf (temp,"%d",integer);
	*this = temp;
	return *this;
}

CMyString & CMyString::operator=(long linteger)
{
	char temp[80];
	sprintf (temp,"%d",linteger);
	*this = temp;
	return *this;
}

CMyString & CMyString::operator=(float floating)
{
	char temp[40];
	sprintf(temp,"%g",floating);
	*this = temp;
	return *this;
}

CMyString & CMyString::operator=(double lfloating)
{
	char temp[40];
	sprintf(temp,"%g",lfloating);
	*this = temp;
	return *this;
}

CMyString & CMyString::operator=(char *string) // string.operator=(char *string);
{
	Delete();
	if (!string) return *this;
	size= strlen(string);
	allocSize = size +1;
	value = new char[allocSize];
	if (!value) throw CMyExceptionMemory("CMyString","operator=(char *)",allocSize);
	strcpy(value,string);
	return *this; // pour: s=t=u="coucou";
}

CMyString & CMyString::operator=(CMyString &string)
{
	Delete();
	if (!string.value) return *this;
	size = string.size;
	allocSize = size +1;
	value = new char[allocSize];
	if (!value) throw CMyExceptionMemory("CMyString","operator=(CMyString &)",allocSize);
	strcpy (value,string.value);
	return *this;
}

// *********************************************************************************

BOOL CMyString::operator==(char letter) 
{
	CMyString temp = letter;
	return !strcmp (value,temp.value);
}

BOOL CMyString::operator==(int integer) 
{
	CMyString temp = integer;
	return !strcmp (value,temp.value);
}

BOOL CMyString::operator==(long linteger) 
{
	CMyString temp = linteger;
	return !strcmp (value,temp.value);
}

BOOL CMyString::operator==(float floating) 
{
	CMyString temp = floating;
	return !strcmp (value,temp.value);
}

BOOL CMyString::operator==(double lfloating) 
{
	CMyString temp = lfloating;
	return !strcmp (value,temp.value);
}

BOOL CMyString::operator==(char *string) 
{
	if (!string) return FALSE;
	return !strcmp (value,string);
}

BOOL CMyString::operator==(CMyString &string)
{
	return !strcmp (value,string.value);
}

// *********************************************************************************

void CMyString::operator+=(char letter)
{
	CMyString temp = letter;
	*this+=temp;
}

void CMyString::operator+=(int integer)
{
	CMyString temp = integer;
	*this += temp;
}

void CMyString::operator+=(long linteger)
{
	CMyString temp = linteger;
	*this += temp;
}

void CMyString::operator+=(float floating)
{
	CMyString temp = floating;
	*this += temp;
}

void CMyString::operator+=(double lfloating)
{
	CMyString temp = lfloating;
	*this += temp;
}

void CMyString::operator+=(char *string)
{
	if (!string) *this;
	if (!value) *this = "";

	long addSize = strlen(string);
	Resize (size+addSize,TRUE);
	strcat (value,string);
	size+= addSize;
}

void CMyString::operator+=(CMyString &string)
{
	*this+=string.value;
}

// *********************************************************************************

CMyString operator+(CMyString &string1,char *string2)
{
	CMyString temp = string1;
	if (!string2) return temp;
	temp += string2;
	return temp;
}

// *********************************************************************************

CMyString operator+(char *string1,CMyString &string2)
{
	CMyString temp;
	if (!string1)
	{
		temp = string2;
		return temp;
	}
	temp = string1;
	temp += string2;
	return temp;
}

// *********************************************************************************

CMyString operator+(CMyString &string,char letter)
{
	CMyString temp = string;
	temp += letter;
	return temp;
}

CMyString operator+(char letter,CMyString &string)
{
	CMyString temp = letter;
	temp += string;
	return temp;
}

CMyString operator+(CMyString &string,int integer)
{
	CMyString temp = string;
	temp += integer;
	return temp;
}

CMyString operator+(int integer,CMyString &string)
{
	CMyString temp = integer;
	temp += string;
	return temp;
}

CMyString operator+(CMyString &string,long linteger)
{
	CMyString temp = string;
	temp += linteger;
	return temp;
}

CMyString operator+(long linteger,CMyString &string)
{
	CMyString temp = linteger;
	temp += string;
	return temp;
}

CMyString operator+(CMyString &string,float floating)
{
	CMyString temp = string;
	temp += floating;
	return temp;
}

CMyString operator+(float floating,CMyString &string)
{
	CMyString temp = floating;
	temp += string;
	return temp;
}

CMyString operator+(CMyString &string,double lfloating)
{
	CMyString temp = string;
	temp += lfloating;
	return temp;
}

CMyString operator+(double lfloating,CMyString &string)
{
	CMyString temp = lfloating;
	temp += string;
	return temp;
}

CMyString operator+(CMyString &string1,CMyString &string2)
{
	CMyString temp = string1;
	temp += string2;
	return temp;
}

/* *********************************************************************************
	Ex.:
	CMyString temp = "coucou";
	if (temp[1]=='o') temp[2]='i';
	// temp == "coicou"
********************************************************************************* */

char &CMyString::operator [] (int index)
{
	if (index>=0 && index<size) return value[index];
	if (index<0 && index>=-size) return value[size+index];

	CMyString temp;
	temp <<"out of bounds: index <> [-"<<size<<";"<<size<<"]";
	throw CMyException("CMyString","operator[](int)",temp);
}

// *********************************************************************************

CMyString::operator char *() const
{
	return value;
}

// *********************************************************************************

CMyString & operator << (CMyString& string , char letter)
{
	string += letter;
	return string;
}

CMyString & operator << (CMyString& string , int integer)
{
	string += integer;
	return string;
}

CMyString & operator << (CMyString& string , long linteger)
{
	string += linteger;
	return string;
}

CMyString & operator << (CMyString& string , float floating)
{
	string += floating;
	return string;
}

CMyString & operator << (CMyString& string , double lfloating)
{
	string += lfloating;
	return string;
}

CMyString & operator << (CMyString& string1 , char *string2)
{
	string1 += string2;
	return string1;
}

CMyString & operator << (CMyString& string1 , CMyString &string2)
{
	string1 += string2;
	return string1;
}

/*
friend CMyString & operator >> (CString& string , char *string2)
{
	return NULL;
}
*/

// *********************************************************************************

BOOL CMyString::Resize()
{
	return Resize(strlen(value),TRUE);
}

// *********************************************************************************

BOOL CMyString::Resize(int newSize,BOOL recopy)
{
	char *newValue = new char[newSize+1];
	if (!newValue) throw CMyExceptionMemory("CMyString","Resize",newSize+1);
	if (recopy && value) 
	{
		int curSize = min(newSize,allocSize-1);
		strncpy(newValue,value,newSize);
		newValue[curSize]='\0';
		Delete();
		size = curSize;
		allocSize = newSize+1;
	}
	else 
	{
		Delete();
		size = 0;
		allocSize = newSize+1;
		newValue[0]='\0';
	}
	value = newValue;
	return TRUE;
}

// *********************************************************************************

void CMyString::SplitPath(CMyString *drive,CMyString *dir,CMyString *file,CMyString *ext,CMyString *driveDir,CMyString *fileExt)
{
   char _drive[_MAX_DRIVE];
   char _dir[_MAX_DIR];
   char _file[_MAX_FNAME];
   char _ext[_MAX_EXT];

   _splitpath(value,(drive||driveDir)?_drive:NULL,(dir||driveDir)?_dir:NULL,(file||fileExt)?_file:NULL,(ext||fileExt)?_ext:NULL);

   if (drive) *drive=_drive;
   if (dir) *dir=_dir;
   if (file) *file=_file;
   if (ext) *ext=_ext;
   if (fileExt) { *fileExt=""; *fileExt<<_file<<_ext; }
   if (driveDir) { *driveDir=""; *driveDir<<_drive<<_dir; }
}
