#ifndef INCLUDE_MYSTRING_H
#define INCLUDE_MYSTRING_H

/* --------------------------------------------------------------- 
	Ex de test!
	CMyString temp,a,b,c;

	a = "coucou";
	b = "toi";
	c = a;
	temp = a + "lui";
	c = "hello " + b;
	temp = a + b;
--------------------------------------------------------------- */

class CMyString
{
	public:
		CMyString();
		~CMyString();

		void Delete();
		BOOL Resize();
		BOOL Resize(int newSize,BOOL recopy=FALSE);
		BOOL IsEmpty();

		CMyString(char letter);
		CMyString(int integer);
		CMyString(long linteger);
		CMyString(float floating);
		CMyString(double lfloating);
		CMyString(char *string,BOOL isOwnerBuffer=FALSE);
		CMyString(CMyString &string);

		void operator+=(char letter);
		void operator+=(int integer);
		void operator+=(long linteger);
		void operator+=(float floating);
		void operator+=(double lfloating);
		void operator+=(char *string);
		void operator+=(CMyString &string);

		CMyString & operator=(char letter);
		CMyString & operator=(int integer);
		CMyString & operator=(long linteger);
		CMyString & operator=(float floating);
		CMyString & operator=(double lfloating);
		CMyString & operator=(char *string);
		CMyString & operator=(CMyString &string);

		BOOL operator==(char letter);
		BOOL operator==(int integer);
		BOOL operator==(long linteger);
		BOOL operator==(float floating);
		BOOL operator==(double lfloating);
		BOOL operator==(char *string);
		BOOL operator==(CMyString &string);

		friend CMyString operator+(CMyString &string,char letter);
		friend CMyString operator+(char letter,CMyString &string);

		friend CMyString operator+(CMyString &string,int integer);
		friend CMyString operator+(int integer,CMyString &string);

		friend CMyString operator+(CMyString &string,long linteger);
		friend CMyString operator+(long linteger,CMyString &string);

		friend CMyString operator+(CMyString &string,float floating);
		friend CMyString operator+(float floating,CMyString &string);

		friend CMyString operator+(CMyString &string,double lfloating);
		friend CMyString operator+(double lfloating,CMyString &string);

		friend CMyString operator+(CMyString &string1,char *string2);
		friend CMyString operator+(char *string1,CMyString &string2);

		friend CMyString operator+(CMyString &string1,CMyString &string2);

		char & operator [] (int num);
		operator char *() const;

		friend CMyString & operator << (CMyString& string , char letter);
		friend CMyString & operator << (CMyString& string , int integer);
		friend CMyString & operator << (CMyString& string , long linteger);
		friend CMyString & operator << (CMyString& string , float floating);
		friend CMyString & operator << (CMyString& string , double lfloating);
		friend CMyString & operator << (CMyString& string1 , char *string2);
		friend CMyString & operator << (CMyString& string1 , CMyString &string2);

		void SplitPath(CMyString *drive,CMyString *dir,CMyString *file,CMyString *ext,CMyString *driveDir,CMyString *fileExt);

	public:
		char *value;
		long size;

	private:
		BOOL isOwnerBuffer;
		long allocSize;
};

#endif